﻿init python:
    import random
    # import time
    # random.seed(time.clock())
    def chance(percent):
        c = random.randint(0, 100)
        if c < percent:
            return True
        else:
            return False
    renpy.music.register_channel("sfx1", "sfx", False)

    class sling_class(renpy.Displayable):
        def __init__(self, image):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.player = None
            self.x = 0
            self.y = 0
            self.x_velocity = 0
            self.y_velocity = 0
            self.rotation = 0

            self.half_screen_width = 960
            self.half_screen_height = 540
            self.alive = True
            self.terminal_velocity = 550
            self.gravity = 2
        def restart(self):
            self.x = 0
            self.y = 0
            self.x_velocity = 0
            self.y_velocity = 0
            self.alive = True
        def sling(self, drags, drops):
            if self.alive:
                Play("sfx1", "sling/bow.ogg")()
                self.x_velocity = -(drags[0].x - 100)
                self.y_velocity = -(drags[0].y - 100)

                drags[0].snap(100, 100, delay=.05)
                renpy.restart_interaction()

        def render(self,width,height,st,at):
            img = self.image
            if self.alive:
                if self.y > self.half_screen_height-20:
                    Play("sound", "sling/drop.ogg")()
                    self.alive = False
                    renpy.restart_interaction()
                else:
                    if self.y_velocity < self.terminal_velocity:
                        self.y_velocity += self.gravity
                    
                    if abs(self.x) > 396:
                            self.x_velocity = -self.x_velocity
                            Play("sound", "sling/wall.ogg")()


                    self.rotation += self.x_velocity*.1
                    self.x += self.x_velocity*.1
                    self.y += self.y_velocity*.1



            t = Transform(img, xanchor=0.5, yanchor=0.5, rotate = self.rotation, zoom = 3, nearest = True)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))
            
            renpy.redraw(self, 0)
            return rv
image sling_image = Crop((0,0,32,32), "sling")
image sling_frame = Crop((96,32,32,32), "sling")
image sling_wall = Crop((0,64,32,32), "sling")
image sling_lave:
    Crop((0,96,32,32), "sling")
    .1
    Crop((32,96,32,32), "sling")
    .1
    Crop((64,96,32,32), "sling")
    .1
    Crop((96,96,32,32), "sling")
    .1
    repeat
default sling_ins = sling_class("sling_image")

screen sling_screen(g = sling_ins):
    modal True
    fixed xysize 1160,740 align .5,.5:
        at zoom(3, True)
        frame align .5,.5 padding 0,0 background "#202020":
            hbox spacing 290:
                vbox align .5,.5:
                    for i in range(12):
                        add "sling_wall"
                vbox align .5,.5:
                    for i in range(12):
                        add "sling_wall"
        drag:
            xysize 960,540 pos 100,100
            dragged g.sling
            frame:
                background None
    
    add g align .5,.5

    hbox align .5,1.0:
        at zoom(3)
        for i in range(9):
            add "sling_lave"
    vbox:
        text str(g.x)
        text str(g.y)
        text str(g.x_velocity)
        text str(g.y_velocity)
    if not g.alive:
        button align .5,.5:
            background Frame("sling_frame", 4,4) padding 20,20
            text "Restart"
            action Function(g.restart)

transform zoom(z, n = False):
    nearest n
    zoom z
label sling_example:
    call screen sling_screen